#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>


// 01 00 00 00 14 00 03 00 00 00 61 1a 01 00 00 00 00 00
// 
// ^^^^^^^^^^^ ^^^^^ ^^^^^ ^^^^^ ^^^^^^^^^^^ ^^^^^^^^^^^
//   userid    kills death victs    points    flag points
#pragma pack(1) // byte aligned

#define PData struct PData_
struct PData_
{
     long userid;     // 4 bytes
    short kills;      // 2 bytes
    short deaths;     // 2 bytes
    short victorys;   // 2 bytes
     long points;     // 4 bytes
     long flagpoints; // 4 bytes
	                  //---------
};                    // 18 bytes

#define SHOWHELP printf("SCRConvert by divine.216\n");printf("use: 'scrconv -iINFILE [-oOUTFILE]'\n");printf("     if not defined -o, will assume you want to edit it.\n");printf("     if defined -o, will assume you want to output a log file.\n");

int main(int argc,char **argv);

int main(int argc,char **argv)
{
    int i = 0;
    unsigned int ui = 0;
	int output = 0;
    FILE *fpin;
	FILE *fpout;
    int flagged = 0;
    char fileinname[20]="0";
    char fileoutname[20]="0";
    for(i=0;i<argc;i++)
    {
        if(argv[i][0] == '-')
        {
            flagged = 1;
            switch(argv[i][1])
            {
                case 'i':
                    strcpy(fileinname,argv[i]+2);
                break;
                case 'o':
					output = 1;
                    strcpy(fileoutname,argv[i]+2);
                break;
                case '?':
					SHOWHELP
                    return 0;
                break;
            }
        }
    }
    if(!flagged)
    {
        SHOWHELP
        return 0;
    }
    if(fileinname[0] == '0')
    {
        printf("Please specify an input file (see scrread -?)\n");
        return 0;
    }
    fpin = fopen(fileinname,"rb");
    if(fpin)
    {
        long fsize;
        fseek(fpin,0,SEEK_END);
        fsize = ftell(fpin);
        if(fsize)
        {
			PData *playerlist;
            int numread = 0,numelem = 0,sizepdata = 0;
            playerlist = malloc(fsize);
			rewind(fpin);
			i = 0;
			sizepdata = sizeof(PData);
			numelem = fsize / sizeof(PData);
			numread = fread(playerlist,sizeof(PData),numelem,fpin);
            if(numread)
            {
				if(output)
				{
					if(fileoutname[0] == '0')
					{
						char *cptr;
						strcpy(fileoutname,fileinname);
						cptr = strchr(fileoutname,'.');
						cptr++;
						cptr[0] = 'l';
						cptr[1] = 'o';
						cptr[2] = 'g';
						cptr[3] = '\0';
						printf("Using default '%s' output filename.\n",fileoutname);
					}
			        fpout = fopen(fileoutname,"w+");
				    fclose(fpin);
					if(fpout)
	                {
		                i = 0;
			            while(i < numread)
				        {//1145897
					        fprintf(fpout,"    UserID:%li\n",playerlist[i].userid);
						    fprintf(fpout,"     Kills:%hi\n",playerlist[i].kills);
							fprintf(fpout,"    Deaths:%hi\n",playerlist[i].deaths);
				            fprintf(fpout,"  Victorys:%hi\n",playerlist[i].victorys);
					        fprintf(fpout,"KillPoints:%li\n",playerlist[i].points);
						    fprintf(fpout,"FlagPoints:%li\n",playerlist[i].flagpoints);
							i++;
	                    }
		                fclose(fpout);
			            printf("Good lord all the shit worked! File Created: %s.\n",fileoutname);
				        return 0;
					}
	                else
		            {
			            printf("Sorry man, couldn't open up the output file...you some kinda accessless newbie?\n");
				        return 0;
					}
				}
				else
				{
					char buffer[25],buff[25];
					char ending,*chptr;
					long userid = 0;
					int currentplayer = 0;;
					printf("%i Players Loaded.\n",numread);
research:
					printf(" Input UserID to edit:");
					scanf("%s",buffer);
					chptr = &ending;
					userid = strtol(buffer,&chptr,10);
					if(userid)
					{
						unsigned char choice;
						short i_sho = 0;
						long  i_lon = 0;
						printf("Userid (%li) Valid, searching...\n",userid);
						i = 0;
						while(i < numread)
						{
							if(playerlist[i].userid == userid)
							{
								printf("   (U)serID    : %li\n",playerlist[i].userid);
								printf("  ------------- -------\n");
								printf("   (K)ills     : %hi\n",playerlist[i].kills);
								printf("   (D)eaths    : %hi\n",playerlist[i].deaths);
								printf("   (V)ictorys  : %hi\n",playerlist[i].victorys);
								printf("   (P)oints    : %li\n",playerlist[i].points);
								printf("   (F)lagPoints: %li\n",playerlist[i].flagpoints);
								break;
							}
							i++;
						}
						printf("Select the Category:");
doagain:
						choice = getchar();
						switch(choice)
						{
							case 'U':
							case 'u':
								printf("New UserID:");
								scanf("%s",buff);
								playerlist[i].userid = atol(buff);
								printf("Players userid adjusted to: %ld\n",playerlist[i].userid);
							case 'K':
							case 'k':
								printf("New Kills:");
								scanf("%s",buff);
								playerlist[i].kills = atoi(buff);
								printf("Players kills adjusted to: %d\n",playerlist[i].kills);
							break;

							case 'D':
							case 'd':
								printf("New Deaths:");
								scanf("%s",buff);
								playerlist[i].deaths = atoi(buff);
								printf("Player deaths adjusted to: %d\n",playerlist[i].deaths);
							break;

							case 'V':
							case 'v':
								printf("New Victorys:");
								scanf("%s",buff);
								playerlist[i].victorys = atoi(buff);
								printf("Player victorys adjusted to: %d\n",playerlist[i].victorys);
							break;

							case 'P':
							case 'p':
								printf("New Points (kill points):");
								scanf("%s",buff);
								playerlist[i].points = atol(buff);
								printf("Player points adjusted to: %ld\n",playerlist[i].points);
							break;

							case 'F':
							case 'f':
								printf("New Flag Points:");
								scanf("%s",buff);
								playerlist[i].flagpoints = atol(buff);
								printf("Player flag points adjusted to: %ld\n",playerlist[i].flagpoints);
							break;

							default:
								goto doagain;
							break;
						}
						printf("(S)ave or (E)dit again?");
anotherchoice:
						choice = getchar();
						switch(choice)
						{
							case 'S':
							case 's':
							break;

							case 'E':
							case 'e':
								goto research;
							break;

							default:
								goto anotherchoice;
							break;
						}
						fclose(fpin);
						fileoutname[0] = 0;
						printf("Save As %s?[Y.N]",fileinname);
yeano:
						choice = getchar();
						switch(choice)
						{
							case 'Y':
							case 'y':
								strcpy(fileoutname,fileinname);
							break;

							case 'N':
							case 'n':
							break;

							default:
								goto yeano;
							break;
						}
						if(!fileoutname[0])
						{
							printf("Altenate filename, Save As:");
							scanf("%s",fileoutname);
						}
						fpout = fopen(fileoutname,"wb+");
						if(fpout)
						{
							printf("%lu elements saved.\n",fwrite(playerlist,sizeof(PData),numelem,fpout));
							fclose(fpout);
						}
						else
						{
							printf("Unable to open: %s\n",fileoutname);
						}
						return 0;
					}
					else
					{
						printf("Userid invalid.\n");
						goto research;
					}
				}
			}
			else
			{
			    printf("Sorry man, couldn't load a single fucking data struct!\n");
				return 0;
            }
	    }
		else
        {
	        printf("Its been determined that the filesize is zero. This could mean its zero bytes, or that i'm fucking stupid. Either way, it won't work.\n");
		    return 0;
        }
	}
    else
	{
        printf("Sorry man, couldn't open up the input file...you some kinda accessless newbie?\n");
	    return 0;
    }
}